<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>XCAP_Client Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248490"></a>XCAP_Client Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3><div class="affiliation"><span class="orgname">Voice Sistem SRL<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3></div></div></div><div><p class="copyright">Copyright © 2007 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2012-02-22 18:29:43 +0100 (Wed, 22 Feb 2012) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id277967">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284069">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248017">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248022">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249343">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249583">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249589">1.3.1. <code class="varname">db_url</code>(str)</a></span></dt><dt><span class="section"><a href="#id249637">1.3.2. <code class="varname">xcap_table</code>(str)</a></span></dt><dt><span class="section"><a href="#id248946">1.3.3. <code class="varname">periodical_query</code>(int)</a></span></dt><dt><span class="section"><a href="#id248990">1.3.4. <code class="varname">query_period</code>(int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293431">1.4. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293441">1.5. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293446">1.5.1. 
		<code class="function">refreshXcapDoc</code>
		</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#id293875">2. Developer Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id293556">2.1. 
	     <code class="function">bind_xcap_api(xcap_api_t* api)</code>
     </a></span></dt><dt><span class="section"><a href="#id293905">2.2. 
			<code class="function">get_elem</code>
		</a></span></dt><dt><span class="section"><a href="#id293996">2.3. 
			<code class="function">register_xcb</code>
		</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249607">Set <code class="varname">db_url</code> parameter</a></dt><dt>1.2. <a href="#id248930">Set <code class="varname">xcap_table</code> parameter</a></dt><dt>1.3. <a href="#id248973">Set <code class="varname">periodical_query</code> parameter</a></dt><dt>1.4. <a href="#id293414">Set <code class="varname">query_period</code> parameter</a></dt><dt>2.1. <a href="#id293885"><code class="function">xcap_api</code> structure</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id277967"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284069"></a>1.1. Overview</h2></div></div></div><p> 
	The modules is an XCAP client for OpenSIPS that can be used by other modules.
	It fetches XCAP elements, either documents or part of them, by sending 
	HTTP GET requests. It also offers support for conditional queries.
	It uses libcurl library as a client-side HTTP transfer library.
	</p><p>
	The module offers an xcap client interface with general functions that
	allow requesting for an specific element from an xcap server.
	In addition to that it also offers the service of storing and update
	in database the documents it receives. In this case only an initial
	request to the module is required - xcapGetNewDoc-which is like a 
	request to the module to handle from that point on the referenced
	document so as to promise that the newest version will always be
	present in database.
	</p><p>
	The update method is also configurable, 
	either through periodical queries, applicable to any kind of xcap
	server or with an MI command that should be sent by the server
	upon an update.
	</p><p>
	The module is currently used by the presence_xml module, if the 
	'integrated_xcap_server' parameter is not set.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248017"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248022"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
			The modules is not dependent of any OpenSIPS module.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249343"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libxml-dev</em></span>.
			</p></li><li><p>
				<span class="emphasis"><em>libcurl-dev</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249583"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249589"></a>1.3.1. <code class="varname">db_url</code>(str)</h3></div></div></div><p>
		The database url.
		</p><p>
		<span class="emphasis"><em>	Default value is &#8220;<span class="quote">mysql://opensips:opensipsrw@localhost/opensips</span>&#8221;.	
		</em></span>
		</p><div class="example"><a name="id249607"></a><p class="title"><b>Example 1.1. Set <code class="varname">db_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("xcap_client", "db_url", "dbdriver://username:password@dbhost/dbname")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249637"></a>1.3.2. <code class="varname">xcap_table</code>(str)</h3></div></div></div><p>
		The name of the db table where XCAP documents are stored.
		</p><p>
		<span class="emphasis"><em>	Default value is &#8220;<span class="quote">xcap</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248930"></a><p class="title"><b>Example 1.2. Set <code class="varname">xcap_table</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("xcap_client", "xcap_table", "xcaps")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248946"></a>1.3.3. <code class="varname">periodical_query</code>(int)</h3></div></div></div><p>
		A flag to disable periodical query as an update method for
		the documents the module is responsible for. It could be
		disabled when the xcap server is capable to send the exported
		MI command when a change occurs or when another module in OpenSIPS
		handles updates.
		</p><p>
		To disable it set this parameter to 0.
		</p><p>
		<span class="emphasis"><em>	Default value is &#8220;<span class="quote">1</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248973"></a><p class="title"><b>Example 1.3. Set <code class="varname">periodical_query</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("xcap_client", "periodical_query", 0)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248990"></a>1.3.4. <code class="varname">query_period</code>(int)</h3></div></div></div><p>
		Should be set if periodical query is not disabled. 
		Represents the time interval the xcap servers should be 
		queried for an update
		</p><p>
		To disable it set this parameter to 0.
		</p><p>
		<span class="emphasis"><em>	Default value is &#8220;<span class="quote">100</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293414"></a><p class="title"><b>Example 1.4. Set <code class="varname">query_period</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("xcap_client", "query_period", 50)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293431"></a>1.4. Exported Functions</h2></div></div></div><p>
	None to be used in configuration file.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293441"></a>1.5. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293446"></a>1.5.1. 
		<code class="function">refreshXcapDoc</code>
		</h3></div></div></div><p>
		MI command that should be sent by an xcap server when a
		stored document changes.
		</p><p>
		Name: <span class="emphasis"><em>refreshXcapDoc</em></span>
		</p><p>Parameters:</p><div class="itemizedlist"><ul type="disc"><li><p>document uri: the uri of the document</p></li><li><p>xcap server port: the port of the xcap server</p></li></ul></div><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
...
:refreshXcapDoc:fifo_reply
/xcap-root/resource-lists/users/eyebeam/buddies-resource-list.xml
8000
_empty_line_
...
		</pre></div></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id293875"></a>Chapter 2. Developer Guide</h2></div></div></div><p>
		The module exports a number of functions that allow selecting 
		and retrieving an element from an xcap server and also registering
		a callback to be called when a MI command refreshXcapDoc is received
		and the document in question is retrieved.
   </p><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293556"></a>2.1. 
	     <code class="function">bind_xcap_api(xcap_api_t* api)</code>
     </h2></div></div></div><p>
		This function allows binding the needed functions. 
		</p><div class="example"><a name="id293885"></a><p class="title"><b>Example 2.1. <code class="function">xcap_api</code> structure</b></p><div class="example-contents"><pre class="programlisting">
...
typedef struct xcap_api {
	
	/* xcap node selection and retrieving functions*/
	xcap_get_elem_t get_elem;
	xcap_nodeSel_init_t int_node_sel;
	xcap_nodeSel_add_step_t add_step;
	xcap_nodeSel_add_terminal_t add_terminal;
	xcap_nodeSel_free_t free_node_sel;
	xcapGetNewDoc_t getNewDoc; /* an initial request for the module 
	fo fetch this document that does not exist in xcap db table
	and handle its update*/

	/* function to register a callback to document changes*/
	register_xcapcb_t register_xcb;
}xcap_api_t;
...
			</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293905"></a>2.2. 
			<code class="function">get_elem</code>
		</h2></div></div></div><p>
			Field type:
				</p><pre class="programlisting">
...
typedef char* (*xcap_get_elem_t)(char* xcap_root,
xcap_doc_sel_t* doc_sel, xcap_node_sel_t* node_sel);
...
				</pre><p>
		</p><p>
			This function sends a HTTP request and gets the specified information
			from the xcap server.
		</p><p>
		The parameters signification:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>xcap_root</em></span>-
				the XCAP server address;
			</p></li><li><p>
				<span class="emphasis"><em>doc_sel</em></span>-
				structure with document selection info;
			</p><pre class="programlisting">
Parameter type:
...
typedef struct xcap_doc_sel
{
	str auid; /* application defined Unique ID*/
	int type; /* the type of the path segment
				after the AUID  which must either
				be GLOBAL_TYPE (for "global") or
				USERS_TYPE (for "users") */ 
	str xid; /* the XCAP User Identifier 
				if type is USERS_TYPE */
	str filename; 
}xcap_doc_sel_t;
...
</pre></li><li><p>
<span class="emphasis"><em>node_sel</em></span>-
structure with node selection info;
</p><pre class="programlisting">
Parameter type:
...
typedef struct xcap_node_sel
{
	step_t* steps;
	step_t* last_step;
	int size;
	ns_list_t* ns_list;
	ns_list_t* last_ns;
	int ns_no;

}xcap_node_sel_t;

typedef struct step
{
	str val;
	struct step* next;
}step_t;

typedef struct ns_list
{
	int name;
	str value;
	struct ns_list* next;
}ns_list_t;
...

</pre><p>
		The node selector is represented like a list of steps that will
		be represented in the path string separated by '/' signs. 
		The namespaces for the nodes are stored also in a list, as an
		association of name and value, where the value is to be included
		in the respective string val field of the step.
		</p><p>
		To construct the node structure the following functions in the xcap_api
		structure should be used: 'int_node_sel', 'add_step' and if needed, 
		'add_terminal'.
		</p><p>
		If the intention is to retrieve the whole document this argument must
		be NULL.
		</p></li></ul></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293996"></a>2.3. 
			<code class="function">register_xcb</code>
		</h2></div></div></div><p>
			Field type:
				</p><pre class="programlisting">
...
typedef int (*register_xcapcb_t)(int types, xcap_cb f);
...
	</pre><p>
	</p><p>
	- 'types' parameter can have a combined value of PRES_RULES, RESOURCE_LIST,
	RLS_SERVICES and PIDF_MANIPULATION.
	</p><p>
	-the callback function has type :
	</p><pre class="programlisting">
...
typedef int (xcap_cb)(int doc_type, str xid, char* doc);
...
	</pre><p>
	</p></div></div></div></body></html>
